//
//  MeunViewController.swift
//  Meun
//
//  Created by shupao on 16/4/11.
//  Copyright © 2016年 YR. All rights reserved.
//

import UIKit
let WIDTH = UIScreen.mainScreen().bounds.size.width
let HEIGHT = UIScreen.mainScreen().bounds.size.height
class MeunViewController: UIViewController,UIScrollViewDelegate {

    //定义全局变量
    var selectImg:UIImageView?
    var titleLable:UILabel?
    var titleScrollView:UIScrollView?
    var contentScrollView:UIScrollView?
    var startContentOffsetX:CGFloat = 0.0
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.title = "导航栏"
        self.automaticallyAdjustsScrollViewInsets = false;
        //初始化变量
        self.titleScrollView = UIScrollView(frame:CGRectMake(0, 64, WIDTH, 44))
        self.contentScrollView = UIScrollView(frame:CGRectMake(0, 108, WIDTH, HEIGHT-108))
        self.contentScrollView?.delegate = self
        self.titleScrollView?.backgroundColor = UIColor.whiteColor()
        self.contentScrollView?.pagingEnabled = true
        self.contentScrollView?.showsHorizontalScrollIndicator = false
        self.contentScrollView?.showsVerticalScrollIndicator = false
        view .addSubview(self.titleScrollView!)
        view.addSubview(self.contentScrollView!)
        
        //初始化控制器
        addChildVC()
        
        //初始化title
        setupTitle()
        
        //默认选择第一个控制器
        self.scrollViewDidEndScrollingAnimation(self.contentScrollView!)
        
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func addChildVC() {
        for var i=0 ;i<8;i++
        {
            var tableVC:TableViewController
            tableVC = TableViewController()
            tableVC.title = NSString(format: "标题%ld" ,i+1) as String
            self.addChildViewController(tableVC)
        }
    }
    func setupTitle() {
       for var i=0 ;i<8;i++
       {
        var label:UILabel?
        label = UILabel()
        label!.text = self.childViewControllers[i].title
        let labelW:CGFloat = 80
        let labelH:CGFloat = (self.titleScrollView?.bounds.size.height)!-2
        let labelY:CGFloat = 0
        let lableX:CGFloat = CGFloat(i) * labelW
        label!.frame = CGRectMake(lableX, labelY, labelW, labelH)
        label!.backgroundColor = UIColor.clearColor()
        label!.textColor = UIColor.blackColor()
        label!.textAlignment = NSTextAlignment.Center
        label!.userInteractionEnabled = true
        label!.tag = i
        label!.font = UIFont.systemFontOfSize(15)
        label!.addGestureRecognizer(UITapGestureRecognizer(target: self, action:"titleLabelClick:"))
        self.titleScrollView?.addSubview(label!)
        
        }
        self.titleScrollView?.contentSize = CGSizeMake(8 * 80, 0);
        self.contentScrollView!.contentSize = CGSizeMake(8 * WIDTH, 0);
        self.titleScrollView!.showsHorizontalScrollIndicator = false;
        selectImg = UIImageView(frame:CGRectMake(0, 43, 80, 1));
        selectImg!.backgroundColor = UIColor.orangeColor();
        self.titleScrollView?.addSubview(selectImg!)
    }
    
    //点击事件
    func titleLabelClick(tap:UITapGestureRecognizer){
        let index = tap.view!.tag;
        var offset:CGPoint = self.contentScrollView!.contentOffset;
        offset.x = CGFloat (index) * self.contentScrollView!.frame.size.width;
        self.contentScrollView?.setContentOffset(offset, animated: true);
    }
//    scrollVeiwDelegate
    func scrollViewDidEndScrollingAnimation(scrollView: UIScrollView) {
        let width:CGFloat = scrollView.frame.size.width;
        let height:CGFloat = scrollView.frame.size.height;
        let offsetX:CGFloat = scrollView.contentOffset.x;
        let index:Int = Int(offsetX) / Int(width);
        let willShowVc:UIViewController = self.childViewControllers[index];
        
        // 设置顶部的titleScrollVeiw滚动到中间
        let label:UILabel = self.titleScrollView!.subviews[index] as! UILabel
        var label1:UIView
        label1 = UIView()
        for label1 in self.titleScrollView!.subviews {
            if ((label1.isKindOfClass(UILabel)) == true){
                 let label2:UILabel = label1 as! UILabel
                if (label2.tag != index) {
                    label2.textColor = UIColor.blackColor()
                  
                }else{
                    label2.textColor = UIColor.orangeColor()
                }
            }
        }
        selectImg!.frame = CGRectMake(label.center.x - 40, 43, 80, 1);
        var titleContentOffset:CGPoint = CGPointMake(label.center.x - width * 0.5, 0);
    
        if titleContentOffset.x < 0 {
            titleContentOffset.x = 0
        }
        let maxTitleContentOffsetX :CGFloat = self.titleScrollView!.contentSize.width - width
   
        if titleContentOffset.x > maxTitleContentOffsetX{
                titleContentOffset.x = maxTitleContentOffsetX
            }
        self.titleScrollView?.setContentOffset(titleContentOffset, animated: true)
        //如果已经出现了,就不再重新加载
        if willShowVc.isViewLoaded() == true {
            return;
        }
        willShowVc.view.frame = CGRectMake(width * CGFloat(index), 0, width, height);
        scrollView.addSubview(willShowVc.view)
        
        var offset:CGPoint = self.contentScrollView!.contentOffset;
        offset.x = CGFloat (index) * self.contentScrollView!.frame.size.width;
        self.contentScrollView?.setContentOffset(offset, animated: true);
        self.contentScrollView?.setContentOffset(self.contentScrollView!.contentOffset, animated: true)
    }
    
    func scrollViewDidEndDecelerating(scrollView: UIScrollView) {
        self.scrollViewDidEndScrollingAnimation(scrollView)
    }
    
    func scrollViewDidScroll(scrollView: UIScrollView) {
        let scal:CGFloat = self.contentScrollView!.contentOffset.x / self.contentScrollView!.frame.size.width;
        let leftLabelIndex:Int = Int (scal);
        let rightLabelIndex:Int = Int(scal) + 1;
        if !self.titleScrollView!.subviews[rightLabelIndex].isKindOfClass(UILabel) {
            return;
        }
        // 拿出对应的label
        let leftLabel:UILabel = self.titleScrollView!.subviews[leftLabelIndex] as! UILabel;
        let rightLabel:UILabel = self.titleScrollView!.subviews[rightLabelIndex] as! UILabel
        selectImg!.frame = CGRectMake(leftLabel.frame.width*scal, 43, 80,1);
        
        
        //判断滑动方向
        let endContentOffsetX:CGFloat = scrollView.contentOffset.x;
        if ( endContentOffsetX < startContentOffsetX) {
            //画面从右往左移动，前一页
            let origmiinX:CGFloat = CGRectGetMinX((selectImg?.frame)!)
            if origmiinX <= CGRectGetMaxX(leftLabel.frame) - leftLabel.frame.width / 2 {
                leftLabel.textColor = UIColor.orangeColor()
                rightLabel.textColor = UIColor.blackColor()
            }
        } else if ( endContentOffsetX > startContentOffsetX) {
            //画面从左往右移动，后一页
            let originX:CGFloat = CGRectGetMaxX((selectImg?.frame)!)
            if originX >= CGRectGetMaxX(rightLabel.frame) - rightLabel.frame.width / 2 {
                rightLabel.textColor = UIColor.orangeColor()
                leftLabel.textColor = UIColor.blackColor()
            }
        }
        
    }
    
    func scrollViewWillBeginDragging(scrollView: UIScrollView) {
      //拖动前的起始坐标
         startContentOffsetX = scrollView.contentOffset.x;
    }

    
    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
